Index: NEMO/trunk/src/OCE/IOM/prtctl.F90
===================================================================
--- NEMO/trunk/src/OCE/IOM/prtctl.F90	(revision 13237)
+++ NEMO/trunk/src/OCE/IOM/prtctl.F90	(revision 13286)
@@ -77,508 +70,360 @@
       !!                    clinfo3 : additional information 
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:,:)  , INTENT(in), OPTIONAL ::   tab2d_1
-      REAL(wp), DIMENSION(:,:,:), INTENT(in), OPTIONAL ::   tab3d_1
-      REAL(wp), DIMENSION(:,:,:), INTENT(in), OPTIONAL ::   mask1
-      CHARACTER (len=*)         , INTENT(in), OPTIONAL ::   clinfo1
-      REAL(wp), DIMENSION(:,:)  , INTENT(in), OPTIONAL ::   tab2d_2
-      REAL(wp), DIMENSION(:,:,:), INTENT(in), OPTIONAL ::   tab3d_2
-      REAL(wp), DIMENSION(:,:,:), INTENT(in), OPTIONAL ::   mask2
-      CHARACTER (len=*)         , INTENT(in), OPTIONAL ::   clinfo2
-      INTEGER                   , INTENT(in), OPTIONAL ::   kdim
-      CHARACTER (len=*)         , INTENT(in), OPTIONAL ::   clinfo3
-      !
-      CHARACTER (len=15) :: cl2
-      INTEGER ::  jn, sind, eind, kdir,j_id
+      REAL(wp),         DIMENSION(:,:)    , INTENT(in), OPTIONAL ::   tab2d_1
+      REAL(wp),         DIMENSION(:,:,:)  , INTENT(in), OPTIONAL ::   tab3d_1
+      REAL(wp),         DIMENSION(:,:,:,:), INTENT(in), OPTIONAL ::   tab4d_1
+      REAL(wp),         DIMENSION(:,:)    , INTENT(in), OPTIONAL ::   tab2d_2
+      REAL(wp),         DIMENSION(:,:,:)  , INTENT(in), OPTIONAL ::   tab3d_2
+      REAL(wp),         DIMENSION(:,:,:)  , INTENT(in), OPTIONAL ::   mask1
+      REAL(wp),         DIMENSION(:,:,:)  , INTENT(in), OPTIONAL ::   mask2
+      CHARACTER(len=*), DIMENSION(:)      , INTENT(in), OPTIONAL ::   clinfo    ! information about the tab3d array
+      CHARACTER(len=*)                    , INTENT(in), OPTIONAL ::   clinfo1
+      CHARACTER(len=*)                    , INTENT(in), OPTIONAL ::   clinfo2
+      CHARACTER(len=*)                    , INTENT(in), OPTIONAL ::   clinfo3
+      INTEGER                             , INTENT(in), OPTIONAL ::   kdim
+      !
+      CHARACTER(len=30) :: cl1, cl2
+      INTEGER ::  jn, jl, kdir
+      INTEGER ::  iis, iie, jjs, jje
+      INTEGER ::  itra, inum
       REAL(wp) :: zsum1, zsum2, zvctl1, zvctl2
-      REAL(wp), DIMENSION(jpi,jpj)     :: ztab2d_1, ztab2d_2
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zmask1, zmask2, ztab3d_1, ztab3d_2
-      !!----------------------------------------------------------------------
-
+      !!----------------------------------------------------------------------
+      !
       ! Arrays, scalars initialization 
-      kdir      = jpkm1
-      cl2       = ''
-      zsum1     = 0.e0
-      zsum2     = 0.e0
-      zvctl1    = 0.e0
-      zvctl2    = 0.e0
-      ztab2d_1(:,:)   = 0.e0
-      ztab2d_2(:,:)   = 0.e0
-      ztab3d_1(:,:,:) = 0.e0
-      ztab3d_2(:,:,:) = 0.e0
-      zmask1  (:,:,:) = 1.e0
-      zmask2  (:,:,:) = 1.e0
+      cl1  = ''
+      cl2  = ''
+      kdir = jpkm1
+      itra = 1
 
       ! Control of optional arguments
-      IF( PRESENT(clinfo2) )   cl2                  = clinfo2
-      IF( PRESENT(kdim)    )   kdir                 = kdim
-      IF( PRESENT(tab2d_1) )   ztab2d_1(:,:)        = tab2d_1(:,:)
-      IF( PRESENT(tab2d_2) )   ztab2d_2(:,:)        = tab2d_2(:,:)
-      IF( PRESENT(tab3d_1) )   ztab3d_1(:,:,1:kdir) = tab3d_1(:,:,1:kdir)
-      IF( PRESENT(tab3d_2) )   ztab3d_2(:,:,1:kdir) = tab3d_2(:,:,1:kdir)
-      IF( PRESENT(mask1)   )   zmask1  (:,:,:)      = mask1  (:,:,:)
-      IF( PRESENT(mask2)   )   zmask2  (:,:,:)      = mask2  (:,:,:)
-
-      IF( lk_mpp .AND. jpnij > 1 ) THEN       ! processor number
-         sind = narea
-         eind = narea
-      ELSE                                    ! processors total number
-         sind = 1
-         eind = ijsplt
-      ENDIF
+      IF( PRESENT(clinfo1) )   cl1  = clinfo1
+      IF( PRESENT(clinfo2) )   cl2  = clinfo2
+      IF( PRESENT(kdim)    )   kdir = kdim
+      IF( PRESENT(tab4d_1) )   itra = SIZE(tab4d_1,dim=4)
 
       ! Loop over each sub-domain, i.e. the total number of processors ijsplt
-      DO jn = sind, eind
-         ! Set logical unit
-         j_id = numid(jn - narea + 1)
-         ! Set indices for the SUM control
-         IF( .NOT. lsp_area ) THEN
-            IF (lk_mpp .AND. jpnij > 1)   THEN
-               nictls = MAX(  1, nlditl(jn) )
-               nictle = MIN(jpi, nleitl(jn) )
-               njctls = MAX(  1, nldjtl(jn) )
-               njctle = MIN(jpj, nlejtl(jn) )
-               ! Do not take into account the bound of the domain
-               IF( ibonitl(jn) == -1 .OR. ibonitl(jn) == 2 ) nictls = MAX(2, nictls)
-               IF( ibonjtl(jn) == -1 .OR. ibonjtl(jn) == 2 ) njctls = MAX(2, njctls)
-               IF( ibonitl(jn) ==  1 .OR. ibonitl(jn) == 2 ) nictle = MIN(nictle, nleitl(jn) - 1)
-               IF( ibonjtl(jn) ==  1 .OR. ibonjtl(jn) == 2 ) njctle = MIN(njctle, nlejtl(jn) - 1)
+      DO jl = 1, SIZE(nall_ictls)
+
+         ! define shoter names...
+         iis = nall_ictls(jl)
+         iie = nall_ictle(jl)
+         jjs = nall_jctls(jl)
+         jje = nall_jctle(jl)
+
+         IF( PRESENT(clinfo) ) THEN   ;   inum = numprt_top(jl)
+         ELSE                         ;   inum = numprt_oce(jl)
+         ENDIF
+
+         DO jn = 1, itra
+
+            IF( PRESENT(clinfo3) ) THEN
+               IF    ( clinfo3 == 'tra-ta' )   THEN
+                  zvctl1 = t_ctl(jl)
+               ELSEIF( clinfo3 == 'tra'    )   THEN
+                  zvctl1 = t_ctl(jl)
+                  zvctl2 = s_ctl(jl)
+               ELSEIF( clinfo3 == 'dyn'    )   THEN
+                  zvctl1 = u_ctl(jl)
+                  zvctl2 = v_ctl(jl)
+               ELSE
+                  zvctl1 = tra_ctl(jn,jl)
+               ENDIF
+            ENDIF
+
+            ! 2D arrays
+            IF( PRESENT(tab2d_1) ) THEN
+               IF( PRESENT(mask1) ) THEN   ;   zsum1 = SUM( tab2d_1(iis:iie,jjs:jje) * mask1(iis:iie,jjs:jje,1) )
+               ELSE                        ;   zsum1 = SUM( tab2d_1(iis:iie,jjs:jje)                            )
+               ENDIF
+            ENDIF
+            IF( PRESENT(tab2d_2) ) THEN
+               IF( PRESENT(mask2) ) THEN   ;   zsum2 = SUM( tab2d_2(iis:iie,jjs:jje) * mask2(iis:iie,jjs:jje,1) )
+               ELSE                        ;   zsum2 = SUM( tab2d_2(iis:iie,jjs:jje)                            )
+               ENDIF
+            ENDIF
+
+            ! 3D arrays
+            IF( PRESENT(tab3d_1) ) THEN
+               IF( PRESENT(mask1) ) THEN   ;   zsum1 = SUM( tab3d_1(iis:iie,jjs:jje,1:kdir) * mask1(iis:iie,jjs:jje,1:kdir) )
+               ELSE                        ;   zsum1 = SUM( tab3d_1(iis:iie,jjs:jje,1:kdir)                                 )
+               ENDIF
+            ENDIF
+            IF( PRESENT(tab3d_2) ) THEN
+               IF( PRESENT(mask2) ) THEN   ;   zsum2 = SUM( tab3d_2(iis:iie,jjs:jje,1:kdir) * mask2(iis:iie,jjs:jje,1:kdir) )
+               ELSE                        ;   zsum2 = SUM( tab3d_2(iis:iie,jjs:jje,1:kdir)                                 )
+               ENDIF
+            ENDIF
+
+            ! 4D arrays
+            IF( PRESENT(tab4d_1) ) THEN
+               IF( PRESENT(mask1) ) THEN   ;   zsum1 = SUM( tab4d_1(iis:iie,jjs:jje,1:kdir,jn) * mask1(iis:iie,jjs:jje,1:kdir) )
+               ELSE                        ;   zsum1 = SUM( tab4d_1(iis:iie,jjs:jje,1:kdir,jn)                                 )
+               ENDIF
+            ENDIF
+
+            ! Print the result
+            IF( PRESENT(clinfo ) )   cl1  = clinfo(jn)
+            IF( PRESENT(clinfo3) )   THEN
+               !
+               IF( PRESENT(tab2d_2) .OR. PRESENT(tab3d_2) ) THEN
+                  WRITE(inum, "(3x,a,' : ',D23.16,3x,a,' : ',D23.16)") cl1, zsum1 - zvctl1, cl2, zsum2 - zvctl2
+               ELSE
+                  WRITE(inum, "(3x,a,' : ',D23.16                  )") cl1, zsum1 - zvctl1
+               ENDIF
+               !
+               SELECT CASE( clinfo3 )
+               CASE ( 'tra-ta' ) 
+                  t_ctl(jl) = zsum1
+               CASE ( 'tra' ) 
+                  t_ctl(jl) = zsum1
+                  s_ctl(jl) = zsum2
+               CASE ( 'dyn' ) 
+                  u_ctl(jl) = zsum1
+                  v_ctl(jl) = zsum2
+               CASE default
+                  tra_ctl(jn,jl) = zsum1
+               END SELECT
+            ELSEIF ( PRESENT(tab2d_2) .OR. PRESENT(tab3d_2) )   THEN
+               WRITE(inum, "(3x,a,' : ',D23.16,3x,a,' : ',D23.16)") cl1, zsum1, cl2, zsum2
             ELSE
-               nictls = MAX(  1, nimpptl(jn) - 1 + nlditl(jn) )
-               nictle = MIN(jpi, nimpptl(jn) - 1 + nleitl(jn) )
-               njctls = MAX(  1, njmpptl(jn) - 1 + nldjtl(jn) )
-               njctle = MIN(jpj, njmpptl(jn) - 1 + nlejtl(jn) )
-               ! Do not take into account the bound of the domain
-               IF( ibonitl(jn) == -1 .OR. ibonitl(jn) == 2 ) nictls = MAX(2, nictls)
-               IF( ibonjtl(jn) == -1 .OR. ibonjtl(jn) == 2 ) njctls = MAX(2, njctls)
-               IF( ibonitl(jn) ==  1 .OR. ibonitl(jn) == 2 ) nictle = MIN(nictle, nimpptl(jn) + nleitl(jn) - 2)
-               IF( ibonjtl(jn) ==  1 .OR. ibonjtl(jn) == 2 ) njctle = MIN(njctle, njmpptl(jn) + nlejtl(jn) - 2)
-            ENDIF
-         ENDIF
-
-         IF( PRESENT(clinfo3)) THEN
-            IF ( clinfo3 == 'tra' )  THEN
-               zvctl1 = t_ctll(jn)
-               zvctl2 = s_ctll(jn)
-            ELSEIF ( clinfo3 == 'dyn' )   THEN
-               zvctl1 = u_ctll(jn)
-               zvctl2 = v_ctll(jn)
-            ENDIF
-         ENDIF
-
-         ! Compute the sum control
-         ! 2D arrays
-         IF( PRESENT(tab2d_1) )   THEN
-            zsum1 = SUM( ztab2d_1(nictls:nictle,njctls:njctle)*zmask1(nictls:nictle,njctls:njctle,1) )
-            zsum2 = SUM( ztab2d_2(nictls:nictle,njctls:njctle)*zmask2(nictls:nictle,njctls:njctle,1) )
-         ENDIF
-
-         ! 3D arrays
-         IF( PRESENT(tab3d_1) )   THEN
-            zsum1 = SUM( ztab3d_1(nictls:nictle,njctls:njctle,1:kdir)*zmask1(nictls:nictle,njctls:njctle,1:kdir) )
-            zsum2 = SUM( ztab3d_2(nictls:nictle,njctls:njctle,1:kdir)*zmask2(nictls:nictle,njctls:njctle,1:kdir) )
-         ENDIF
-
-         ! Print the result
-         IF( PRESENT(clinfo3) )   THEN
-            WRITE(j_id,FMT='(a,D23.16,3x,a,D23.16)')clinfo1, zsum1-zvctl1, cl2, zsum2-zvctl2
-            SELECT CASE( clinfo3 )
-            CASE ( 'tra-ta' ) 
-               t_ctll(jn) = zsum1
-            CASE ( 'tra' ) 
-                t_ctll(jn) = zsum1
-                s_ctll(jn) = zsum2
-            CASE ( 'dyn' ) 
-                u_ctll(jn) = zsum1
-                v_ctll(jn) = zsum2 
-            END SELECT
-         ELSEIF ( PRESENT(clinfo2) .OR. PRESENT(tab2d_2) .OR. PRESENT(tab3d_2) )   THEN
-            WRITE(j_id,FMT='(a,D23.16,3x,a,D23.16)')clinfo1, zsum1, cl2, zsum2
-         ELSE
-            WRITE(j_id,FMT='(a,D23.16)')clinfo1, zsum1
-         ENDIF
-
-      ENDDO
-      !
-   END SUBROUTINE prt_ctl
-
-
-   SUBROUTINE prt_ctl_info (clinfo1, ivar1, clinfo2, ivar2, itime)
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE prt_ctl_info  ***
-      !!
-      !! ** Purpose : - print information without any computation
-      !!
-      !! ** Action  : - input arguments
-      !!                    clinfo1 : information about the ivar1
-      !!                    ivar1   : value to print
-      !!                    clinfo2 : information about the ivar2
-      !!                    ivar2   : value to print
-      !!----------------------------------------------------------------------
-      CHARACTER (len=*), INTENT(in)           ::   clinfo1
-      INTEGER          , INTENT(in), OPTIONAL ::   ivar1
-      CHARACTER (len=*), INTENT(in), OPTIONAL ::   clinfo2
-      INTEGER          , INTENT(in), OPTIONAL ::   ivar2
-      INTEGER          , INTENT(in), OPTIONAL ::   itime
-      !
-      INTEGER :: jn, sind, eind, iltime, j_id
-      !!----------------------------------------------------------------------
-
-      IF( lk_mpp .AND. jpnij > 1 ) THEN       ! processor number
-         sind = narea
-         eind = narea
-      ELSE                                    ! total number of processors
-         sind = 1
-         eind = ijsplt
-      ENDIF
-
-      ! Set to zero arrays at each new time step
-      IF( PRESENT(itime) )   THEN
-         iltime = itime
-         IF( iltime > ktime )   THEN
-            t_ctll(:) = 0.e0   ;   s_ctll(:) = 0.e0
-            u_ctll(:) = 0.e0   ;   v_ctll(:) = 0.e0
-            ktime = iltime
-         ENDIF
-      ENDIF
-
-      ! Loop over each sub-domain, i.e. number of processors ijsplt
-      DO jn = sind, eind
-         !
-         j_id = numid(jn - narea + 1)         ! Set logical unit
-         !
-         IF( PRESENT(ivar1) .AND. PRESENT(clinfo2) .AND. PRESENT(ivar2) )   THEN
-            WRITE(j_id,*)clinfo1, ivar1, clinfo2, ivar2
-         ELSEIF ( PRESENT(ivar1) .AND. PRESENT(clinfo2) .AND. .NOT. PRESENT(ivar2) )   THEN
-            WRITE(j_id,*)clinfo1, ivar1, clinfo2
-         ELSEIF ( PRESENT(ivar1) .AND. .NOT. PRESENT(clinfo2) .AND. PRESENT(ivar2) )   THEN
-            WRITE(j_id,*)clinfo1, ivar1, ivar2
-         ELSEIF ( PRESENT(ivar1) .AND. .NOT. PRESENT(clinfo2) .AND. .NOT. PRESENT(ivar2) )   THEN
-            WRITE(j_id,*)clinfo1, ivar1
-         ELSE
-            WRITE(j_id,*)clinfo1
-         ENDIF
-         !
-      END DO
-      !
-   END SUBROUTINE prt_ctl_info
-
-
-   SUBROUTINE prt_ctl_init
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE prt_ctl_init  ***
-      !!
-      !! ** Purpose :   open ASCII files & compute indices
-      !!----------------------------------------------------------------------
-      INTEGER ::   jn, sind, eind, j_id
-      CHARACTER (len=28) :: clfile_out
-      CHARACTER (len=23) :: clb_name
-      CHARACTER (len=19) :: cl_run
-      !!----------------------------------------------------------------------
-
-      ! Allocate arrays
-      ALLOCATE( nlditl(ijsplt) , nleitl(ijsplt) , nimpptl(ijsplt) , ibonitl(ijsplt) ,   &
-         &      nldjtl(ijsplt) , nlejtl(ijsplt) , njmpptl(ijsplt) , ibonjtl(ijsplt) ,   &
-         &      nlcitl(ijsplt) , t_ctll(ijsplt) , u_ctll (ijsplt) ,                     &
-         &      nlcjtl(ijsplt) , s_ctll(ijsplt) , v_ctll (ijsplt)                       )
-
-      ! Initialization 
-      t_ctll(:) = 0.e0
-      s_ctll(:) = 0.e0
-      u_ctll(:) = 0.e0
-      v_ctll(:) = 0.e0
-      ktime = 1
-
-      IF( lk_mpp .AND. jpnij > 1 ) THEN
-         sind = narea
-         eind = narea
-         clb_name = "('mpp.output_',I4.4)"
-         cl_run = 'MULTI processor run'
-         ! use indices for each area computed by mpp_init subroutine
-         nlditl(1:jpnij) = nldit(:) 
-         nleitl(1:jpnij) = nleit(:) 
-         nldjtl(1:jpnij) = nldjt(:) 
-         nlejtl(1:jpnij) = nlejt(:) 
-         !
-         nimpptl(1:jpnij) = nimppt(:)
-         njmpptl(1:jpnij) = njmppt(:)
-         !
-         nlcitl(1:jpnij) = nlcit(:)
-         nlcjtl(1:jpnij) = nlcjt(:)
-         !
-         ibonitl(1:jpnij) = ibonit(:)
-         ibonjtl(1:jpnij) = ibonjt(:)
-      ELSE
-         sind = 1
-         eind = ijsplt
-         clb_name = "('mono.output_',I4.4)"
-         cl_run = 'MONO processor run '
-         ! compute indices for each area as done in mpp_init subroutine
-         CALL sub_dom
-      ENDIF
-
-      ALLOCATE( numid(eind-sind+1) )
-
-      DO jn = sind, eind
-         WRITE(clfile_out,FMT=clb_name) jn-1
-         CALL ctl_opn( numid(jn -narea + 1), clfile_out, 'REPLACE', 'FORMATTED', 'SEQUENTIAL', 1, numout, .FALSE. )
-         j_id = numid(jn -narea + 1)
-         WRITE(j_id,*)
-         WRITE(j_id,*) '                 L O D Y C - I P S L'
-         WRITE(j_id,*) '                     O P A model'
-         WRITE(j_id,*) '            Ocean General Circulation Model'
-         WRITE(j_id,*) '               version OPA 9.0  (2005) '
-         WRITE(j_id,*)
-         WRITE(j_id,*) '                   PROC number: ', jn
-         WRITE(j_id,*)
-         WRITE(j_id,FMT="(19x,a20)")cl_run
-
-         ! Print the SUM control indices
-         IF( .NOT. lsp_area )   THEN
-            nictls = nimpptl(jn) + nlditl(jn) - 1
-            nictle = nimpptl(jn) + nleitl(jn) - 1
-            njctls = njmpptl(jn) + nldjtl(jn) - 1
-            njctle = njmpptl(jn) + nlejtl(jn) - 1
-         ENDIF
-         WRITE(j_id,*) 
-         WRITE(j_id,*) 'prt_ctl :  Sum control indices'
-         WRITE(j_id,*) '~~~~~~~'
-         WRITE(j_id,*)
-         WRITE(j_id,9000)'                                nlej   = ', nlejtl(jn), '              '
-         WRITE(j_id,9000)'                  ------------- njctle = ', njctle, ' -------------'
-         WRITE(j_id,9001)'                  |                                       |'
-         WRITE(j_id,9001)'                  |                                       |'
-         WRITE(j_id,9001)'                  |                                       |'
-         WRITE(j_id,9002)'           nictls = ', nictls,  '                           nictle = ', nictle
-         WRITE(j_id,9002)'           nldi   = ', nlditl(jn),  '                           nlei   = ', nleitl(jn)
-         WRITE(j_id,9001)'                  |                                       |'
-         WRITE(j_id,9001)'                  |                                       |'
-         WRITE(j_id,9001)'                  |                                       |'
-         WRITE(j_id,9004)'  njmpp  = ',njmpptl(jn),'   ------------- njctls = ', njctls, ' -------------'
-         WRITE(j_id,9003)'           nimpp  = ', nimpptl(jn), '        nldj   = ', nldjtl(jn), '              '
-         WRITE(j_id,*)
-         WRITE(j_id,*)
-
-9000     FORMAT(a41,i4.4,a14)
-9001     FORMAT(a59)
-9002     FORMAT(a20,i4.4,a36,i3.3)
-9003     FORMAT(a20,i4.4,a17,i4.4)
-9004     FORMAT(a11,i4.4,a26,i4.4,a14)
-      END DO
-      !
-   END SUBROUTINE prt_ctl_init
-
-
-   SUBROUTINE sub_dom
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE sub_dom  ***
-      !!                    
-      !! ** Purpose :   Lay out the global domain over processors. 
-      !!                CAUTION: 
-      !!                This part has been extracted from the mpp_init
-      !!                subroutine and names of variables/arrays have been 
-      !!                slightly changed to avoid confusion but the computation
-      !!                is exactly the same. Any modification about indices of
-      !!                each sub-domain in the mppini.F90 module should be reported 
-      !!                here.
-      !!
-      !! ** Method  :   Global domain is distributed in smaller local domains.
-      !!                Periodic condition is a function of the local domain position
-      !!                (global boundary or neighbouring domain) and of the global
-      !!                periodic
-      !!                Type :         jperio global periodic condition
-      !!
-      !! ** Action  : - set domain parameters
-      !!                    nimpp     : longitudinal index 
-      !!                    njmpp     : latitudinal  index
-      !!                    narea     : number for local area
-      !!                    nlcil      : first dimension
-      !!                    nlcjl      : second dimension
-      !!                    nbondil    : mark for "east-west local boundary"
-      !!                    nbondjl    : mark for "north-south local boundary"
-      !!
-      !! History :
-      !!        !  94-11  (M. Guyon)  Original code
-      !!        !  95-04  (J. Escobar, M. Imbard)
-      !!        !  98-02  (M. Guyon)  FETI method
-      !!        !  98-05  (M. Imbard, J. Escobar, L. Colombet )  SHMEM and MPI versions
-      !!   8.5  !  02-08  (G. Madec)  F90 : free form
-      !!----------------------------------------------------------------------
-      INTEGER ::   ji, jj, jn               ! dummy loop indices
-      INTEGER ::   &
-         ii, ij,                         &  ! temporary integers
-         irestil, irestjl,               &  !    "          "
-         ijpi  , ijpj, nlcil,            &  ! temporary logical unit
-         nlcjl , nbondil, nbondjl,       &
-         nrecil, nrecjl, nldil, nleil, nldjl, nlejl
-
-      INTEGER, DIMENSION(jpi,jpj) ::   iimpptl, ijmpptl, ilcitl, ilcjtl   ! workspace
-      REAL(wp) ::   zidom, zjdom            ! temporary scalars
-      INTEGER ::   inum                     ! local logical unit
-      !!----------------------------------------------------------------------
-
-      !
-      !
-      !  1. Dimension arrays for subdomains
-      ! -----------------------------------
-      !  Computation of local domain sizes ilcitl() ilcjtl()
-      !  These dimensions depend on global sizes isplt,jsplt and jpiglo,jpjglo
-      !  The subdomains are squares leeser than or equal to the global
-      !  dimensions divided by the number of processors minus the overlap
-      !  array (cf. par_oce.F90).
-
-#if defined key_nemocice_decomp
-      ijpi = ( nx_global+2-2*nn_hls + (isplt-1) ) / isplt + 2*nn_hls
-      ijpj = ( ny_global+2-2*nn_hls + (jsplt-1) ) / jsplt + 2*nn_hls 
-#else
-      ijpi = ( jpiglo-2*nn_hls + (isplt-1) ) / isplt + 2*nn_hls
-      ijpj = ( jpjglo-2*nn_hls + (jsplt-1) ) / jsplt + 2*nn_hls
-#endif
-
-
-      nrecil  = 2 * nn_hls
-      nrecjl  = 2 * nn_hls
-      irestil = MOD( jpiglo - nrecil , isplt )
-      irestjl = MOD( jpjglo - nrecjl , jsplt )
-
-      IF(  irestil == 0 )   irestil = isplt
-#if defined key_nemocice_decomp
-
-      ! In order to match CICE the size of domains in NEMO has to be changed
-      ! The last line of blocks (west) will have fewer points 
-      DO jj = 1, jsplt 
-         DO ji=1, isplt-1 
-            ilcitl(ji,jj) = ijpi 
-         END DO 
-         ilcitl(isplt,jj) = jpiglo - (isplt - 1) * (ijpi - nrecil)
-      END DO 
-
-#else 
-
-      DO jj = 1, jsplt
-         DO ji = 1, irestil
-            ilcitl(ji,jj) = ijpi
-         END DO
-         DO ji = irestil+1, isplt
-            ilcitl(ji,jj) = ijpi -1
+               WRITE(inum, "(3x,a,' : ',D23.16                  )") cl1, zsum1
+            ENDIF
+
          END DO
       END DO
-
-#endif
-      
-      IF( irestjl == 0 )   irestjl = jsplt
-#if defined key_nemocice_decomp 
-
-      ! Same change to domains in North-South direction as in East-West. 
-      DO ji = 1, isplt 
-         DO jj=1, jsplt-1 
-            ilcjtl(ji,jj) = ijpj 
-         END DO 
-         ilcjtl(ji,jsplt) = jpjglo - (jsplt - 1) * (ijpj - nrecjl)
-      END DO 
-
-#else 
-
-      DO ji = 1, isplt
-         DO jj = 1, irestjl
-            ilcjtl(ji,jj) = ijpj
-         END DO
-         DO jj = irestjl+1, jsplt
-            ilcjtl(ji,jj) = ijpj -1
-         END DO
+      !
+   END SUBROUTINE prt_ctl
+
+
+   SUBROUTINE prt_ctl_info (clinfo, ivar, cdcomp )
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE prt_ctl_info  ***
+      !!
+      !! ** Purpose : - print information without any computation
+      !!
+      !! ** Action  : - input arguments
+      !!                    clinfo : information about the ivar
+      !!                    ivar   : value to print
+      !!----------------------------------------------------------------------
+      CHARACTER(len=*),           INTENT(in) ::   clinfo
+      INTEGER         , OPTIONAL, INTENT(in) ::   ivar
+      CHARACTER(len=3), OPTIONAL, INTENT(in) ::   cdcomp   ! only 'top' is accepted
+      !
+      CHARACTER(len=3) :: clcomp
+      INTEGER ::  jl, inum
+      !!----------------------------------------------------------------------
+      !
+      IF( PRESENT(cdcomp) ) THEN   ;   clcomp = cdcomp
+      ELSE                         ;   clcomp = 'oce'
+      ENDIF
+      !
+      DO jl = 1, SIZE(nall_ictls)
+         !
+         IF( clcomp == 'oce' )   inum = numprt_oce(jl)
+         IF( clcomp == 'top' )   inum = numprt_top(jl)
+         !
+         IF ( PRESENT(ivar) ) THEN   ;   WRITE(inum,*) clinfo, ivar
+         ELSE                        ;   WRITE(inum,*) clinfo
+         ENDIF
+         !
       END DO
-
-#endif
-      zidom = nrecil
-      DO ji = 1, isplt
-         zidom = zidom + ilcitl(ji,1) - nrecil
+      !
+   END SUBROUTINE prt_ctl_info
+
+
+   SUBROUTINE prt_ctl_init( cdcomp, kntra )
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE prt_ctl_init  ***
+      !!
+      !! ** Purpose :   open ASCII files & compute indices
+      !!----------------------------------------------------------------------
+      CHARACTER(len=3), OPTIONAL, INTENT(in   ) ::   cdcomp   ! only 'top' is accepted
+      INTEGER         , OPTIONAL, INTENT(in   ) ::   kntra    ! only for 'top': number of tracers
+      !
+      INTEGER ::   ji, jj, jl
+      INTEGER ::   inum, idg, idg2
+      INTEGER ::   ijsplt, iimax, ijmax
+      INTEGER, DIMENSION(:,:), ALLOCATABLE ::    iimppt, ijmppt, ijpi, ijpj, iproc
+      INTEGER, DIMENSION(  :), ALLOCATABLE ::     iipos,  ijpos
+      LOGICAL, DIMENSION(:,:), ALLOCATABLE ::   llisoce
+      CHARACTER(len=64) :: clfile_out
+      CHARACTER(LEN=64) :: clfmt, clfmt2, clfmt3, clfmt4
+      CHARACTER(len=32) :: clname, cl_run
+      CHARACTER(len= 3) :: clcomp
+      !!----------------------------------------------------------------------
+      !
+      clname = 'output'
+      IF( PRESENT(cdcomp) ) THEN
+         clname = TRIM(clname)//'.'//TRIM(cdcomp)
+         clcomp = cdcomp
+      ELSE
+         clcomp = 'oce'
+      ENDIF
+      !
+      IF( jpnij > 1 ) THEN   ! MULTI processor run
+         cl_run = 'MULTI processor run'
+         idg = MAX( INT(LOG10(REAL(MAX(1,jpnij-1),wp))) + 1, 4 )    ! how many digits to we need to write? min=4, max=9
+         WRITE(clfmt, "('(a,i', i1, '.', i1, ')')") idg, idg        ! '(a,ix.x)'
+         WRITE(clfile_out,clfmt) 'mpp.'//trim(clname)//'_', narea - 1
+         ijsplt = 1
+      ELSE                   ! MONO processor run
+         cl_run = 'MONO processor run '
+         IF(lwp) THEN                  ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) 'prt_ctl_init: sn_cfctl%l_prtctl parameters'
+            WRITE(numout,*) '~~~~~~~~~~~~~'
+         ENDIF
+         IF( nn_ictls+nn_ictle+nn_jctls+nn_jctle == 0 )   THEN    ! print control done over the default area         
+            nn_isplt = MAX(1, nn_isplt)            ! number of processors following i-direction
+            nn_jsplt = MAX(1, nn_jsplt)            ! number of processors following j-direction
+            ijsplt = nn_isplt * nn_jsplt           ! total number of processors ijsplt
+            IF( ijsplt == 1 )   CALL ctl_warn( 'nn_isplt & nn_jsplt are equal to 1 -> control sum done over the whole domain' )
+            IF(lwp) WRITE(numout,*) '      number of proc. following i     nn_isplt   = ', nn_isplt
+            IF(lwp) WRITE(numout,*) '      number of proc. following j     nn_jsplt   = ', nn_jsplt
+            idg = MAX( INT(LOG10(REAL(MAX(1,ijsplt-1),wp))) + 1, 4 )    ! how many digits to we need to write? min=4, max=9
+            WRITE(clfmt, "('(a,i', i1, '.', i1, ')')") idg, idg         ! '(a,ix.x)'
+            IF( ijsplt == 1 ) WRITE(clfile_out,clfmt) 'mono.'//trim(clname)//'_', 0
+         ELSE                                             ! print control done over a specific  area
+            ijsplt = 1
+            IF( nn_ictls < 1 .OR. nn_ictls > Ni0glo )   THEN
+               CALL ctl_warn( '          - nictls must be 1<=nictls>=Ni0glo, it is forced to 1' )
+               nn_ictls = 1
+            ENDIF
+            IF( nn_ictle < 1 .OR. nn_ictle > Ni0glo )   THEN
+               CALL ctl_warn( '          - nictle must be 1<=nictle>=Ni0glo, it is forced to Ni0glo' )
+               nn_ictle = Ni0glo
+            ENDIF
+            IF( nn_jctls < 1 .OR. nn_jctls > Nj0glo )   THEN
+               CALL ctl_warn( '          - njctls must be 1<=njctls>=Nj0glo, it is forced to 1' )
+               nn_jctls = 1
+            ENDIF
+            IF( nn_jctle < 1 .OR. nn_jctle > Nj0glo )   THEN
+               CALL ctl_warn( '          - njctle must be 1<=njctle>=Nj0glo, it is forced to Nj0glo' )
+               nn_jctle = Nj0glo
+            ENDIF
+            WRITE(numout,*) '      Start i indice for SUM control  nn_ictls   = ', nn_ictls
+            WRITE(numout,*) '      End i indice for SUM control    nn_ictle   = ', nn_ictle
+            WRITE(numout,*) '      Start j indice for SUM control  nn_jctls   = ', nn_jctls
+            WRITE(numout,*) '      End j indice for SUM control    nn_jctle   = ', nn_jctle
+            idg = MAXVAL( (/ nn_ictls,nn_ictle,nn_jctls,nn_jctle /) )   ! temporary use of idg to store the largest index
+            idg = MAX( INT(LOG10(REAL(idg,wp))) + 1, 4 )                ! how many digits to we need to write? min=4, max=9
+            WRITE(clfmt, "('(4(a,i', i1, '.', i1, '))')") idg, idg         ! '(4(a,ix.x))'
+            WRITE(clfile_out,clfmt) 'mono.'//trim(clname)//'_', nn_ictls, '_', nn_ictle, '_', nn_jctls, '_', nn_jctle
+         ENDIF
+      ENDIF
+
+      ! Allocate arrays
+      IF( .NOT. ALLOCATED(nall_ictls) ) ALLOCATE( nall_ictls(ijsplt), nall_ictle(ijsplt), nall_jctls(ijsplt), nall_jctle(ijsplt) )
+
+      IF( jpnij > 1 ) THEN   ! MULTI processor run
+         !
+         nall_ictls(1) = Nis0
+         nall_ictle(1) = Nie0
+         nall_jctls(1) = Njs0
+         nall_jctle(1) = Nje0
+         !
+      ELSE                   ! MONO processor run
+         !
+         IF( nn_ictls+nn_ictle+nn_jctls+nn_jctle == 0 )   THEN    ! print control done over the default area
+            !
+            ALLOCATE(  iimppt(nn_isplt,nn_jsplt), ijmppt(nn_isplt,nn_jsplt),  ijpi(nn_isplt,nn_jsplt),  ijpj(nn_isplt,nn_jsplt),   &
+               &      llisoce(nn_isplt,nn_jsplt),  iproc(nn_isplt,nn_jsplt), iipos(nn_isplt*nn_jsplt), ijpos(nn_isplt*nn_jsplt) )
+            CALL mpp_basesplit( jpiglo, jpjglo, nn_hls, nn_isplt, nn_jsplt, iimax, ijmax, iimppt, ijmppt, ijpi, ijpj )
+            CALL mpp_is_ocean( llisoce )
+            CALL mpp_getnum( llisoce, iproc, iipos, ijpos )
+            !
+            DO jj = 1,nn_jsplt
+               DO ji = 1, nn_isplt
+                  jl = iproc(ji,jj) + 1
+                  nall_ictls(jl) = iimppt(ji,jj) - 1 +      1      + nn_hls
+                  nall_ictle(jl) = iimppt(ji,jj) - 1 + ijpi(ji,jj) - nn_hls
+                  nall_jctls(jl) = ijmppt(ji,jj) - 1 +      1      + nn_hls
+                  nall_jctle(jl) = ijmppt(ji,jj) - 1 + ijpj(ji,jj) - nn_hls
+               END DO
+            END DO
+            !
+            DEALLOCATE( iimppt, ijmppt, ijpi, ijpj, llisoce, iproc, iipos, ijpos )
+            !
+         ELSE                                             ! print control done over a specific  area
+            !
+            nall_ictls(1) = nn_ictls + nn_hls
+            nall_ictle(1) = nn_ictle + nn_hls
+            nall_jctls(1) = nn_jctls + nn_hls
+            nall_jctle(1) = nn_jctle + nn_hls
+            !
+         ENDIF
+      ENDIF
+
+      ! Initialization 
+      IF( clcomp == 'oce' ) THEN
+         ALLOCATE( t_ctl(ijsplt), s_ctl(ijsplt), u_ctl(ijsplt), v_ctl(ijsplt), numprt_oce(ijsplt) )
+         t_ctl(:) = 0.e0
+         s_ctl(:) = 0.e0
+         u_ctl(:) = 0.e0
+         v_ctl(:) = 0.e0
+      ENDIF
+      IF( clcomp == 'top' ) THEN
+         ALLOCATE( tra_ctl(kntra,ijsplt), numprt_top(ijsplt) )
+         tra_ctl(:,:) = 0.e0
+      ENDIF
+
+      DO jl = 1,ijsplt
+
+         IF( ijsplt > 1 ) WRITE(clfile_out,clfmt) 'mono.'//trim(clname)//'_', jl-1
+
+         CALL ctl_opn( inum, clfile_out, 'REPLACE', 'FORMATTED', 'SEQUENTIAL', 1, numout, .FALSE. )
+         IF( clcomp == 'oce' )   numprt_oce(jl) = inum
+         IF( clcomp == 'top' )   numprt_top(jl) = inum
+         WRITE(inum,*)
+         WRITE(inum,*) '   CNRS - NERC - Met OFFICE - MERCATOR-ocean - CMCC'
+         WRITE(inum,*) '                       NEMO team'
+         WRITE(inum,*) '            Ocean General Circulation Model'
+         IF( clcomp == 'oce' )   WRITE(inum,*) '                NEMO version 4.x  (2020) '
+         IF( clcomp == 'top' )   WRITE(inum,*) '                 TOP vversion x (2020) '
+         WRITE(inum,*)
+         IF( ijsplt > 1 )   &
+            &   WRITE(inum,*) '              MPI-subdomain number: ', jl-1
+         IF(  jpnij > 1 )   &
+            &   WRITE(inum,*) '              MPI-subdomain number: ', narea-1
+         WRITE(inum,*)
+         WRITE(inum,'(19x,a20)') cl_run
+         WRITE(inum,*) 
+         WRITE(inum,*) 'prt_ctl :  Sum control indices'
+         WRITE(inum,*) '~~~~~~~'
+         WRITE(inum,*)
+         !
+         ! clfmt2: '              ----- jctle = XXX (YYY) -----'             -> '(18x, 13a1, a9, iM, a2, iN, a2, 13a1)'
+         ! clfmt3: '              |                           |'             -> '(18x, a1, Nx, a1)'
+         ! clfmt4: '        ictls = XXX (YYY)           ictle = XXX (YYY)'   -> '(Nx, a9, iM, a2, iP, a2, Qx, a9, iM, a2, iP, a2)'
+         !         '              |                           |'
+         !         '              ----- jctle = XXX (YYY) -----'
+         ! clfmt5: '   njmpp = XXX'                                          -> '(Nx, a9, iM)'
+         ! clfmt6: '           nimpp = XXX'                                  -> '(Nx, a9, iM)'
+         !
+         idg = MAXVAL( (/ nall_ictls(jl), nall_ictle(jl), nall_jctls(jl), nall_jctle(jl) /) )   ! temporary use of idg
+         idg = INT(LOG10(REAL(idg,wp))) + 1                                                     ! how many digits do we use?
+         idg2 = MAXVAL( (/ mig0(nall_ictls(jl)), mig0(nall_ictle(jl)), mjg0(nall_jctls(jl)), mjg0(nall_jctle(jl)) /) )
+         idg2 = INT(LOG10(REAL(idg2,wp))) + 1                                                   ! how many digits do we use?
+         WRITE(clfmt2, "('(18x, 13a1, a9, i', i1, ', a2, i',i1,', a2, 13a1)')") idg, idg2
+         WRITE(clfmt3, "('(18x, a1, ', i2,'x, a1)')") 13+9+idg+2+idg2+2+13 - 2
+         WRITE(clfmt4, "('(', i2,'x, a9, i', i1,', a2, i', i1,', a2, ', i2,'x, a9, i', i1,', a2, i', i1,', a2)')") &
+            &          18-7, idg, idg2, 13+9+idg+2+idg2+2+13 - (2+idg+2+idg2+2+8), idg, idg2
+         WRITE(inum,clfmt2) ('-', ji=1,13), ' jctle = ', nall_jctle(jl), ' (', mjg0(nall_jctle(jl)), ') ', ('-', ji=1,13)
+         WRITE(inum,clfmt3) '|', '|'
+         WRITE(inum,clfmt3) '|', '|'
+         WRITE(inum,clfmt3) '|', '|'
+         WRITE(inum,clfmt4)                 ' ictls = ', nall_ictls(jl), ' (', mig0(nall_ictls(jl)), ') ',   &
+            &                               ' ictle = ', nall_ictle(jl), ' (', mig0(nall_ictle(jl)), ') '
+         WRITE(inum,clfmt3) '|', '|'
+         WRITE(inum,clfmt3) '|', '|'
+         WRITE(inum,clfmt3) '|', '|'
+         WRITE(inum,clfmt2) ('-', ji=1,13), ' jctls = ', nall_jctls(jl), ' (', mjg0(nall_jctls(jl)), ') ', ('-', ji=1,13)
+         WRITE(inum,*)
+         WRITE(inum,*)
+         !
       END DO
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*)' sum ilcitl(i,1) = ', zidom, ' jpiglo = ', jpiglo
-      
-      zjdom = nrecjl
-      DO jj = 1, jsplt
-         zjdom = zjdom + ilcjtl(1,jj) - nrecjl
-      END DO
-      IF(lwp) WRITE(numout,*)' sum ilcitl(1,j) = ', zjdom, ' jpjglo = ', jpjglo
-      IF(lwp) WRITE(numout,*)
-      
-
-      !  2. Index arrays for subdomains
-      ! -------------------------------
-
-      iimpptl(:,:) = 1
-      ijmpptl(:,:) = 1
-      
-      IF( isplt > 1 ) THEN
-         DO jj = 1, jsplt
-            DO ji = 2, isplt
-               iimpptl(ji,jj) = iimpptl(ji-1,jj) + ilcitl(ji-1,jj) - nrecil
-            END DO
-         END DO
-      ENDIF
-
-      IF( jsplt > 1 ) THEN
-         DO jj = 2, jsplt
-            DO ji = 1, isplt
-               ijmpptl(ji,jj) = ijmpptl(ji,jj-1)+ilcjtl(ji,jj-1)-nrecjl
-            END DO
-         END DO
-      ENDIF
-      
-      ! 3. Subdomain description
-      ! ------------------------
-
-      DO jn = 1, ijsplt
-         ii = 1 + MOD( jn-1, isplt )
-         ij = 1 + (jn-1) / isplt
-         nimpptl(jn) = iimpptl(ii,ij)
-         njmpptl(jn) = ijmpptl(ii,ij)
-         nlcitl (jn) = ilcitl (ii,ij)     
-         nlcil       = nlcitl (jn)     
-         nlcjtl (jn) = ilcjtl (ii,ij)     
-         nlcjl       = nlcjtl (jn)
-         nbondjl = -1                                    ! general case
-         IF( jn   >  isplt          )   nbondjl = 0      ! first row of processor
-         IF( jn   >  (jsplt-1)*isplt )  nbondjl = 1     ! last  row of processor
-         IF( jsplt == 1             )   nbondjl = 2      ! one processor only in j-direction
-         ibonjtl(jn) = nbondjl
-         
-         nbondil = 0                                     ! 
-         IF( MOD( jn, isplt ) == 1 )   nbondil = -1      !
-         IF( MOD( jn, isplt ) == 0 )   nbondil =  1      !
-         IF( isplt            == 1 )   nbondil =  2      ! one processor only in i-direction
-         ibonitl(jn) = nbondil
-         
-         nldil =  1   + nn_hls
-         nleil = nlcil - nn_hls
-         IF( nbondil == -1 .OR. nbondil == 2 )   nldil = 1
-         IF( nbondil ==  1 .OR. nbondil == 2 )   nleil = nlcil
-         nldjl =  1   + nn_hls
-         nlejl = nlcjl - nn_hls
-         IF( nbondjl == -1 .OR. nbondjl == 2 )   nldjl = 1
-         IF( nbondjl ==  1 .OR. nbondjl == 2 )   nlejl = nlcjl
-         nlditl(jn) = nldil
-         nleitl(jn) = nleil
-         nldjtl(jn) = nldjl
-         nlejtl(jn) = nlejl
-      END DO
-      !
-      ! Save processor layout in layout_prtctl.dat file 
-      IF(lwp) THEN
-         CALL ctl_opn( inum, 'layout_prtctl.dat', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE., narea )
-         WRITE(inum,'(a)') 'nproc nlcil nlcjl nldil nldjl nleil nlejl nimpptl njmpptl ibonitl ibonjtl'
-         !
-         DO jn = 1, ijsplt
-            WRITE(inum,'(i5,6i6,4i8)') jn-1,nlcitl(jn),  nlcjtl(jn), &
-               &                            nlditl(jn),  nldjtl(jn), &
-               &                            nleitl(jn),  nlejtl(jn), &
-               &                           nimpptl(jn), njmpptl(jn), &
-               &                           ibonitl(jn), ibonjtl(jn)
-         END DO
-         CLOSE(inum)   
-      END IF
-      !
-      !
-   END SUBROUTINE sub_dom
+      !
+   END SUBROUTINE prt_ctl_init
+
 
    !!======================================================================
